#==============================================================================
#
#  $Id: movemail.py,v 1.2 2000/04/27 23:24:35 mike Exp $
#
"""
   Temporary script to move a UNIX mailbox into a spugmail database.
"""
#
#  Copyright (C) 1999 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#  $Log: movemail.py,v $
#  Revision 1.2  2000/04/27 23:24:35  mike
#  Now converts multiple mailbox files.
#
#  Revision 1.1.1.1  2000/04/02 19:09:03  mike
#  Spug Mailer and libraries.
#
#
#==============================================================================

import sys, os
sys.path.insert(0, '../..')

import mailbox, shelve, string
from spug.mail.message import MessageHeaders, MessageInfo, Message

def moveMailbox(mailbox, db):
   index = []
   
   i = 0
   while 1:
      msg = mailbox.next()
      if not msg:
         break
      
      # construct a message object for the message
   
      # first step is to construct the headers list
      headers = MessageHeaders()
      headers.parseFrom(msg.headers)
      
      # next we insert the MessageInfo instance into the body.
      
      # from field is either the full name or e-mail address (if full name
      # is not provided).
      fromInfo = msg.getaddr('from')
      if fromInfo[0]:
         fromField = fromInfo[0]
      else:
         fromField = fromInfo[1]
      
      # parse the date field into a 9-tuple
      dateField = msg.getdate('date')
   
      status = msg.getheader('status')
      unread = not status or 'R' not in status      
   
      index.append(MessageInfo(fromField,
                               msg.getheader('to'),
                               dateField,
                               msg.getheader('subject'),
                               unread,
                               i
                               )
                   )
      
      # create a message object
      msgObj = Message(headers, msg.fp.read())
      
      # now we store the Message object itself into the database
      db[str(i)] = msgObj
      
      i = i + 1            
      
   db['index'] = index
   db['next'] = i


for file in os.listdir('tmp/mail'):
   if not os.path.exists('tmp/spugmail/%s' % file):
      mailFileFp = open('tmp/mail/%s' % file)
      mailbx = mailbox.UnixMailbox(mailFileFp)
      
      tmpfile = 'tmp/spugmail/%s.tmp' % file
      
      if os.path.exists(tmpfile):
         os.remove(tmpfile)
      
      db = shelve.open(tmpfile)
      print 'moving %s...' % file
      moveMailbox(mailbx, db)
      
      os.rename(tmpfile, 'tmp/spugmail/%s' % file)

